
public class CurrencyImpl {

	private String units;
	private long amount;
	private int cents;

	public CurrencyImpl(double amount, String code) {
		this.units = code;
		setAmount(amount);
	}

	private void setAmount(double amount) {
		this.amount = new Double(amount).longValue();
		this.cents = (int) ((amount * 100.0) % 100);
	}

	public CurrencyImpl toEuros(ExchangeRate converter) {
		if ("EUR".equals(units))
			return this;
		else {
			double input = amount + cents / 100.0;
			double rate;
			rate = converter.getRate(units, "EUR");
			double output = input * rate;
			return new CurrencyImpl(output, "EUR");
		}
	}

	public boolean equals(Object o) {
		if (o instanceof CurrencyImpl) {
			CurrencyImpl other = (CurrencyImpl) o;
			return this.units.equals(other.units)
					&& this.amount == other.amount && this.cents == other.cents;
		}
		return false;
	}

	public String toString() {
		return amount + "." + Math.abs(cents) + " " + units;
	}

}