import org.easymock.EasyMock;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.testng.AbstractTestNGSpringContextTests;
import org.testng.Assert;
import org.testng.annotations.Test;

@ContextConfiguration(locations = { "/appContext.xml" })
public class CurrencyTest extends AbstractTestNGSpringContextTests {

	@Autowired
	@Qualifier("usd")
	private CurrencyImpl testObject;

	@Autowired
	@Qualifier("eur")
	private CurrencyImpl expected;
	
	@Autowired
	@Qualifier("someServiceMock")
	private ExchangeRate mock;
	
	@Test
    public void testToEuros() {
        EasyMock.expect(mock.getRate("USD", "EUR")).andReturn(1.5);
		EasyMock.replay(mock);
		CurrencyImpl actual = testObject.toEuros(mock);
		Assert.assertEquals(expected, actual);
    }

}